#*********************************************************************************************
#                                 Fait par JGP SOLDAT
#                               Maintenu par Kana-chan
#                             Pour l'Alliance Francophone
#                             Version 5.00, le 30 mai 2007 
#                           Première version 27 janvier 2001 
#
#                     (Programme de création de la page Alliance.html)
#                 (et des pages de mini-teams et de la page miniteam.html)
#
#*********************************************************************************************

use Socket;

$version = "Version 7.10";
$destWWW = "/var/www/html";

sub reencode_nom {
  local ($nom_encode) = @_;
  $nom_encode =~ s/%26/%2526/g;
  $nom_encode =~ s/%E7/c/g;
  $nom_encode =~ s/%e7/c/g;
  $nom_encode =~ s/ç/c/g;
  return $nom_encode;
}

$fichier_alliance = "AllTeam51.txt";
$fichier_non_associes = "Non-associes.txt";
$nom_incorrect = "Nom vide ";
$compteur_nom_incorrect = 1;

$team = 1;
while (open(file, "mini$team.team")) {
  $line = "vide";
  while ($line ne "\n" and $line ne "") {
    $line = <file>;
    ($l1, $l2) = split(/\n/, $line, 2);
    if ($l1 ne "") {
      ($eq1, $eq2) = split(/=/, $l1);
      if ($eq1 eq "Miniteam") {
        $tab_team[$team] = $eq2;
      }
    }
  }
  close(file);
  $team++;
}

@tab_alliance = ();

foreach $eq (@tab_team) {
  $last_entry = 0;
  if ($eq eq "") {
    next;
  }
  print("Equipe $eq\n");
  while (open(file, "$destWWW/$eq.txt")) {
    $line = "vide";
    while ($line ne "-------------------------------------------------------------------------------------\n") {
      $line = <file>;
    }
    while ($line ne "\n" and $line ne "") {
      $line = <file>;
      ($l1, $l2) = split(/\n/, $line, 2);
      if ($l1 ne "") {
        $l1 =~ s/ /\t/;
        @li1 = split(/\t/, $l1);
        @line_membre = ();
        foreach $lin (@li1) {
          if ($lin eq "") {
            next;
          }
          # $lin =~ s/ //;
          # print("Elem $lin\n");
          push(@line_membre, $lin);
        }
        # print("NB elements [".($#line_membre+1)."]\n");
        $nom_membre = $line_membre[2];
        if ($#line_membre+1 lt 5) {
          $nom_membre = $nom_incorrect.$compteur_nom_incorrect;
          $compteur_nom_incorrect += 1;
          print("$nom_membre detecte [$eq]");
          foreach $info (@line_membre) {
            print("[$info]");
          }
          print("!\n");
        }
        # print("$line_membre[2] ==> $eq\n");
        push(@tab_alliance, ($nom_membre, $eq));
        $last_entry = $line_membre[0];
      }
    }
    close(file);
    print("Equipe $eq done [$last_entry]\n");
    last;
  }
}

$compteur_nom_incorrect = 1;
@tab_team51 = ();

open(nass, ">$destWWW/$fichier_non_associes");
open(allteam, ">$destWWW/$fichier_alliance");
open(file, "$destWWW/team51.txt");
$line = <file>;
while ($line ne "-------------------------------------------------------------------------------------\n") {
  $line = <file>;
}
$line = <file>;
while ($line ne "\n" and $line ne "") {
  ($l1, $l2) = split(/\n/, $line, 2);
  if ($l1 ne "") {
    $l1 =~ s/ /\t/;
    @li1 = split(/\t/, $l1);
    @membre_team = ();
    foreach $lin (@li1) {
      if ($lin eq "") {
        next;
      }
      # $lin =~ s/ //;
      # print("Elem $lin\n");
      push(@membre_team, $lin);
    }
    # print("NB elements [".($#membre_team+1)."]\n");
    $nom_membre = $membre_team[2];
    if ($#membre_team+1 lt 5) {
      $nom_membre = $nom_incorrect.$compteur_nom_incorrect;
      $compteur_nom_incorrect += 1;
      print("$nom_membre detecte ");
      foreach $info (@membre_team) {
        print("[$info]");
      }
      print("!\n");
    }
    # print("Membre [$nom_membre]\n");
    $alliance_name = "Non-associes";
    $cpt = 0;
    while ($cpt < ($#tab_alliance+1)/2) {
      if ($tab_alliance[2*$cpt] eq $nom_membre) {
        $alliance_name = $tab_alliance[2*$cpt+1];
        last;
      }
      # print("Recherche membre [$cpt][$membre] : [$nom_membre]\n");
      $cpt += 1;
    }
    # print("$membre_team[2] ==> $alliance_name\n");
    # push(@tab_team51, ($membre_team[2], $alliance_name));
    if ($alliance_name eq "Non-associes") {
      print nass ("$nom_membre\t$alliance_name\n");
    }
    print allteam ("$nom_membre\t$alliance_name\n");
    # print("$nom_membre\t$alliance_name\n");
  }
  $line = <file>;
}
close(file);
close(nass);

print("Recherche OK!\n");
